// Generated by rstantools.  Do not edit by hand.

/*
    hwep is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    hwep is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with hwep.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef MODELS_HPP
#define MODELS_HPP
#define STAN__SERVICES__COMMAND_HPP
#ifndef USE_STANC3
#define USE_STANC3
#endif
#include <rstan/rstaninc.hpp>
// Code generated by %%NAME%% %%VERSION%%
#include <stan/model/model_header.hpp>
namespace model_gl_alt_namespace {
inline void validate_positive_index(const char* var_name, const char* expr,
                                    int val) {
  if (val < 1) {
    std::stringstream msg;
    msg << "Found dimension size less than one in simplex declaration"
        << "; variable=" << var_name << "; dimension size expression=" << expr
        << "; expression value=" << val;
    std::string msg_str(msg.str());
    throw std::invalid_argument(msg_str.c_str());
  }
}
inline void validate_unit_vector_index(const char* var_name, const char* expr,
                                       int val) {
  if (val <= 1) {
    std::stringstream msg;
    if (val == 1) {
      msg << "Found dimension size one in unit vector declaration."
          << " One-dimensional unit vector is discrete"
          << " but the target distribution must be continuous."
          << " variable=" << var_name << "; dimension size expression=" << expr;
    } else {
      msg << "Found dimension size less than one in unit vector declaration"
          << "; variable=" << var_name << "; dimension size expression=" << expr
          << "; expression value=" << val;
    }
    std::string msg_str(msg.str());
    throw std::invalid_argument(msg_str.c_str());
  }
}
using std::istream;
using std::string;
using std::stringstream;
using std::vector;
using std::pow;
using stan::io::dump;
using stan::math::lgamma;
using stan::model::model_base_crtp;
using stan::model::rvalue;
using stan::model::cons_list;
using stan::model::index_uni;
using stan::model::index_max;
using stan::model::index_min;
using stan::model::index_min_max;
using stan::model::index_multi;
using stan::model::index_omni;
using stan::model::nil_index_list;
using namespace stan::math;
using stan::math::pow; 
stan::math::profile_map profiles__;
static int current_statement__= 0;
static const std::vector<string> locations_array__ = {" (found before start of program)",
                                                      " (in 'gl_alt', line 8, column 2 to column 19)",
                                                      " (in 'gl_alt', line 11, column 2 to column 36)",
                                                      " (in 'gl_alt', line 13, column 11 to column 14)",
                                                      " (in 'gl_alt', line 13, column 4 to column 19)",
                                                      " (in 'gl_alt', line 15, column 6 to column 35)",
                                                      " (in 'gl_alt', line 14, column 23 to line 16, column 5)",
                                                      " (in 'gl_alt', line 14, column 4 to line 16, column 5)",
                                                      " (in 'gl_alt', line 17, column 4 to column 30)",
                                                      " (in 'gl_alt', line 12, column 17 to line 18, column 3)",
                                                      " (in 'gl_alt', line 12, column 2 to line 18, column 3)",
                                                      " (in 'gl_alt', line 2, column 2 to column 17)",
                                                      " (in 'gl_alt', line 3, column 2 to column 17)",
                                                      " (in 'gl_alt', line 4, column 9 to column 10)",
                                                      " (in 'gl_alt', line 4, column 12 to column 15)",
                                                      " (in 'gl_alt', line 4, column 2 to column 20)",
                                                      " (in 'gl_alt', line 5, column 9 to column 14)",
                                                      " (in 'gl_alt', line 5, column 2 to column 21)",
                                                      " (in 'gl_alt', line 8, column 10 to column 15)"};
#include <stan_meta_header.hpp>
class model_gl_alt final : public model_base_crtp<model_gl_alt> {
private:
  int N;
  int K;
  Eigen::Matrix<double, -1, -1> gl;
  Eigen::Matrix<double, -1, 1> beta;
  int q_1dim__;
 
public:
  ~model_gl_alt() { }
  
  inline std::string model_name() const final { return "model_gl_alt"; }
  inline std::vector<std::string> model_compile_info() const noexcept {
    return std::vector<std::string>{"stanc_version = %%NAME%%3 %%VERSION%%", "stancflags = "};
  }
  
  
  model_gl_alt(stan::io::var_context& context__,
               unsigned int random_seed__ = 0,
               std::ostream* pstream__ = nullptr) : model_base_crtp(0) {
    using local_scalar_t__ = double ;
    boost::ecuyer1988 base_rng__ = 
        stan::services::util::create_rng(random_seed__, 0);
    (void) base_rng__;  // suppress unused var warning
    static const char* function__ = "model_gl_alt_namespace::model_gl_alt";
    (void) function__;  // suppress unused var warning
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    (void) DUMMY_VAR__;  // suppress unused var warning
    
    try {
      int pos__;
      pos__ = std::numeric_limits<int>::min();
      
      pos__ = 1;
      current_statement__ = 11;
      context__.validate_dims("data initialization","N","int",
          context__.to_vec());
      N = std::numeric_limits<int>::min();
      
      current_statement__ = 11;
      N = context__.vals_i("N")[(1 - 1)];
      current_statement__ = 11;
      current_statement__ = 11;
      check_greater_or_equal(function__, "N", N, 0);
      current_statement__ = 12;
      context__.validate_dims("data initialization","K","int",
          context__.to_vec());
      K = std::numeric_limits<int>::min();
      
      current_statement__ = 12;
      K = context__.vals_i("K")[(1 - 1)];
      current_statement__ = 12;
      current_statement__ = 12;
      check_greater_or_equal(function__, "K", K, 2);
      current_statement__ = 13;
      validate_non_negative_index("gl", "N", N);
      current_statement__ = 14;
      validate_non_negative_index("gl", "K + 1", (K + 1));
      current_statement__ = 15;
      context__.validate_dims("data initialization","gl","double",
          context__.to_vec(N, (K + 1)));
      gl = Eigen::Matrix<double, -1, -1>(N, (K + 1));
      stan::math::fill(gl, std::numeric_limits<double>::quiet_NaN());
      
      {
        std::vector<local_scalar_t__> gl_flat__;
        current_statement__ = 15;
        assign(gl_flat__, nil_index_list(), context__.vals_r("gl"),
          "assigning variable gl_flat__");
        current_statement__ = 15;
        pos__ = 1;
        current_statement__ = 15;
        for (int sym1__ = 1; sym1__ <= (K + 1); ++sym1__) {
          current_statement__ = 15;
          for (int sym2__ = 1; sym2__ <= N; ++sym2__) {
            current_statement__ = 15;
            assign(gl,
              cons_list(index_uni(sym2__),
                cons_list(index_uni(sym1__), nil_index_list())),
              gl_flat__[(pos__ - 1)], "assigning variable gl");
            current_statement__ = 15;
            pos__ = (pos__ + 1);}}
      }
      current_statement__ = 16;
      validate_non_negative_index("beta", "K + 1", (K + 1));
      current_statement__ = 17;
      context__.validate_dims("data initialization","beta","double",
          context__.to_vec((K + 1)));
      beta = Eigen::Matrix<double, -1, 1>((K + 1));
      stan::math::fill(beta, std::numeric_limits<double>::quiet_NaN());
      
      {
        std::vector<local_scalar_t__> beta_flat__;
        current_statement__ = 17;
        assign(beta_flat__, nil_index_list(), context__.vals_r("beta"),
          "assigning variable beta_flat__");
        current_statement__ = 17;
        pos__ = 1;
        current_statement__ = 17;
        for (int sym1__ = 1; sym1__ <= (K + 1); ++sym1__) {
          current_statement__ = 17;
          assign(beta, cons_list(index_uni(sym1__), nil_index_list()),
            beta_flat__[(pos__ - 1)], "assigning variable beta");
          current_statement__ = 17;
          pos__ = (pos__ + 1);}
      }
      current_statement__ = 18;
      q_1dim__ = std::numeric_limits<int>::min();
      
      current_statement__ = 18;
      q_1dim__ = (K + 1);
      current_statement__ = 18;
      validate_positive_index("q", "K + 1", q_1dim__);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
      // Next line prevents compiler griping about no return
      throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***"); 
    }
    num_params_r__ = 0U;
    
    try {
      num_params_r__ += (q_1dim__ - 1);
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
      // Next line prevents compiler griping about no return
      throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***"); 
    }
  }
  template <bool propto__, bool jacobian__, typename VecR, typename VecI, stan::require_vector_like_t<VecR>* = nullptr, stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline stan::scalar_type_t<VecR> log_prob_impl(VecR& params_r__,
                                                 VecI& params_i__,
                                                 std::ostream* pstream__ = nullptr) const {
    using T__ = stan::scalar_type_t<VecR>;
    using local_scalar_t__ = T__;
    T__ lp__(0.0);
    stan::math::accumulator<T__> lp_accum__;
    static const char* function__ = "model_gl_alt_namespace::log_prob";
(void) function__;  // suppress unused var warning
    stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    (void) DUMMY_VAR__;  // suppress unused var warning
    
    try {
      Eigen::Matrix<local_scalar_t__, -1, 1> q;
      q = Eigen::Matrix<local_scalar_t__, -1, 1>(q_1dim__);
      stan::math::fill(q, DUMMY_VAR__);
      
      Eigen::Matrix<local_scalar_t__, -1, 1> q_in__;
      q_in__ = Eigen::Matrix<local_scalar_t__, -1, 1>((q_1dim__ - 1));
      stan::math::fill(q_in__, DUMMY_VAR__);
      
      current_statement__ = 1;
      q_in__ = in__.vector((q_1dim__ - 1));
      current_statement__ = 1;
      if (jacobian__) {
        current_statement__ = 1;
        assign(q, nil_index_list(),
          stan::math::simplex_constrain(q_in__, lp__), "assigning variable q");
      } else {
        current_statement__ = 1;
        assign(q, nil_index_list(), stan::math::simplex_constrain(q_in__),
          "assigning variable q");
      }
      {
        current_statement__ = 2;
        lp_accum__.add(dirichlet_lpdf<false>(q, beta));
        current_statement__ = 10;
        for (int i = 1; i <= N; ++i) {
          current_statement__ = 3;
          validate_non_negative_index("lq", "K + 1", (K + 1));
          Eigen::Matrix<local_scalar_t__, -1, 1> lq;
          lq = Eigen::Matrix<local_scalar_t__, -1, 1>((K + 1));
          stan::math::fill(lq, DUMMY_VAR__);
          
          current_statement__ = 7;
          for (int j = 1; j <= (K + 1); ++j) {
            current_statement__ = 5;
            assign(lq, cons_list(index_uni(j), nil_index_list()),
              (rvalue(gl,
                 cons_list(index_uni(i),
                   cons_list(index_uni(j), nil_index_list())), "gl") +
                stan::math::log(q[(j - 1)])), "assigning variable lq");}
          current_statement__ = 8;
          lp_accum__.add(log_sum_exp(lq));}
      }
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
      // Next line prevents compiler griping about no return
      throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***"); 
    }
    lp_accum__.add(lp__);
    return lp_accum__.sum();
    } // log_prob_impl() 
    
  template <typename RNG, typename VecR, typename VecI, typename VecVar, stan::require_vector_like_vt<std::is_floating_point, VecR>* = nullptr, stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr, stan::require_std_vector_vt<std::is_floating_point, VecVar>* = nullptr>
  inline void write_array_impl(RNG& base_rng__, VecR& params_r__,
                               VecI& params_i__, VecVar& vars__,
                               const bool emit_transformed_parameters__ = true,
                               const bool emit_generated_quantities__ = true,
                               std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    vars__.resize(0);
    stan::io::reader<local_scalar_t__> in__(params_r__, params_i__);
    static const char* function__ = "model_gl_alt_namespace::write_array";
(void) function__;  // suppress unused var warning
    (void) function__;  // suppress unused var warning
    double lp__ = 0.0;
    (void) lp__;  // dummy to suppress unused var warning
    stan::math::accumulator<double> lp_accum__;
    local_scalar_t__ DUMMY_VAR__(std::numeric_limits<double>::quiet_NaN());
    (void) DUMMY_VAR__;  // suppress unused var warning
    
    try {
      Eigen::Matrix<double, -1, 1> q;
      q = Eigen::Matrix<double, -1, 1>(q_1dim__);
      stan::math::fill(q, std::numeric_limits<double>::quiet_NaN());
      
      Eigen::Matrix<local_scalar_t__, -1, 1> q_in__;
      q_in__ = Eigen::Matrix<local_scalar_t__, -1, 1>((q_1dim__ - 1));
      stan::math::fill(q_in__, DUMMY_VAR__);
      
      current_statement__ = 1;
      q_in__ = in__.vector((q_1dim__ - 1));
      current_statement__ = 1;
      assign(q, nil_index_list(), stan::math::simplex_constrain(q_in__),
        "assigning variable q");
      for (int sym1__ = 1; sym1__ <= q_1dim__; ++sym1__) {
        vars__.emplace_back(q[(sym1__ - 1)]);}
      if (logical_negation((primitive_value(emit_transformed_parameters__) ||
            primitive_value(emit_generated_quantities__)))) {
        return ;
      } 
      if (logical_negation(emit_generated_quantities__)) {
        return ;
      } 
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
      // Next line prevents compiler griping about no return
      throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***"); 
    }
    } // write_array_impl() 
    
  template <typename VecVar, typename VecI, stan::require_std_vector_t<VecVar>* = nullptr, stan::require_vector_like_vt<std::is_integral, VecI>* = nullptr>
  inline void transform_inits_impl(const stan::io::var_context& context__,
                                   VecI& params_i__, VecVar& vars__,
                                   std::ostream* pstream__ = nullptr) const {
    using local_scalar_t__ = double;
    vars__.clear();
    vars__.reserve(num_params_r__);
    
    try {
      int pos__;
      pos__ = std::numeric_limits<int>::min();
      
      pos__ = 1;
      Eigen::Matrix<double, -1, 1> q;
      q = Eigen::Matrix<double, -1, 1>(q_1dim__);
      stan::math::fill(q, std::numeric_limits<double>::quiet_NaN());
      
      {
        std::vector<local_scalar_t__> q_flat__;
        current_statement__ = 1;
        assign(q_flat__, nil_index_list(), context__.vals_r("q"),
          "assigning variable q_flat__");
        current_statement__ = 1;
        pos__ = 1;
        current_statement__ = 1;
        for (int sym1__ = 1; sym1__ <= q_1dim__; ++sym1__) {
          current_statement__ = 1;
          assign(q, cons_list(index_uni(sym1__), nil_index_list()),
            q_flat__[(pos__ - 1)], "assigning variable q");
          current_statement__ = 1;
          pos__ = (pos__ + 1);}
      }
      Eigen::Matrix<double, -1, 1> q_free__;
      q_free__ = Eigen::Matrix<double, -1, 1>((q_1dim__ - 1));
      stan::math::fill(q_free__, std::numeric_limits<double>::quiet_NaN());
      
      current_statement__ = 1;
      assign(q_free__, nil_index_list(), stan::math::simplex_free(q),
        "assigning variable q_free__");
      for (int sym1__ = 1; sym1__ <= (q_1dim__ - 1); ++sym1__) {
        vars__.emplace_back(q_free__[(sym1__ - 1)]);}
    } catch (const std::exception& e) {
      stan::lang::rethrow_located(e, locations_array__[current_statement__]);
      // Next line prevents compiler griping about no return
      throw std::runtime_error("*** IF YOU SEE THIS, PLEASE REPORT A BUG ***"); 
    }
    } // transform_inits_impl() 
    
  inline void get_param_names(std::vector<std::string>& names__) const {
    
    names__.clear();
    names__.emplace_back("q");
    } // get_param_names() 
    
  inline void get_dims(std::vector<std::vector<size_t>>& dimss__) const {
    dimss__.clear();
    dimss__.emplace_back(std::vector<size_t>{static_cast<size_t>(q_1dim__)});
    
    } // get_dims() 
    
  inline void constrained_param_names(
                                      std::vector<std::string>& param_names__,
                                      bool emit_transformed_parameters__ = true,
                                      bool emit_generated_quantities__ = true) const
    final {
    
    for (int sym1__ = 1; sym1__ <= q_1dim__; ++sym1__) {
      {
        param_names__.emplace_back(std::string() + "q" + '.' + std::to_string(sym1__));
      }}
    if (emit_transformed_parameters__) {
      
    }
    
    if (emit_generated_quantities__) {
      
    }
    
    } // constrained_param_names() 
    
  inline void unconstrained_param_names(
                                        std::vector<std::string>& param_names__,
                                        bool emit_transformed_parameters__ = true,
                                        bool emit_generated_quantities__ = true) const
    final {
    
    for (int sym1__ = 1; sym1__ <= (q_1dim__ - 1); ++sym1__) {
      {
        param_names__.emplace_back(std::string() + "q" + '.' + std::to_string(sym1__));
      }}
    if (emit_transformed_parameters__) {
      
    }
    
    if (emit_generated_quantities__) {
      
    }
    
    } // unconstrained_param_names() 
    
  inline std::string get_constrained_sizedtypes() const {
    stringstream s__;
    s__ << "[{\"name\":\"q\",\"type\":{\"name\":\"vector\",\"length\":" << q_1dim__ << "},\"block\":\"parameters\"}]";
    return s__.str();
    } // get_constrained_sizedtypes() 
    
  inline std::string get_unconstrained_sizedtypes() const {
    stringstream s__;
    s__ << "[{\"name\":\"q\",\"type\":{\"name\":\"vector\",\"length\":" << (q_1dim__ - 1) << "},\"block\":\"parameters\"}]";
    return s__.str();
    } // get_unconstrained_sizedtypes() 
    
  
    // Begin method overload boilerplate
    template <typename RNG>
    inline void write_array(RNG& base_rng,
                            Eigen::Matrix<double,Eigen::Dynamic,1>& params_r,
                            Eigen::Matrix<double,Eigen::Dynamic,1>& vars,
                            const bool emit_transformed_parameters = true,
                            const bool emit_generated_quantities = true,
                            std::ostream* pstream = nullptr) const {
      std::vector<double> vars_vec(vars.size());
      std::vector<int> params_i;
      write_array_impl(base_rng, params_r, params_i, vars_vec,
          emit_transformed_parameters, emit_generated_quantities, pstream);
      vars.resize(vars_vec.size());
      for (int i = 0; i < vars.size(); ++i) {
        vars.coeffRef(i) = vars_vec[i];
      }
    }
    template <typename RNG>
    inline void write_array(RNG& base_rng, std::vector<double>& params_r,
                            std::vector<int>& params_i,
                            std::vector<double>& vars,
                            bool emit_transformed_parameters = true,
                            bool emit_generated_quantities = true,
                            std::ostream* pstream = nullptr) const {
      write_array_impl(base_rng, params_r, params_i, vars, emit_transformed_parameters, emit_generated_quantities, pstream);
    }
    template <bool propto__, bool jacobian__, typename T_>
    inline T_ log_prob(Eigen::Matrix<T_,Eigen::Dynamic,1>& params_r,
                       std::ostream* pstream = nullptr) const {
      Eigen::Matrix<int, -1, 1> params_i;
      return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
    }
    template <bool propto__, bool jacobian__, typename T__>
    inline T__ log_prob(std::vector<T__>& params_r,
                        std::vector<int>& params_i,
                        std::ostream* pstream = nullptr) const {
      return log_prob_impl<propto__, jacobian__>(params_r, params_i, pstream);
    }
  
    inline void transform_inits(const stan::io::var_context& context,
                         Eigen::Matrix<double, Eigen::Dynamic, 1>& params_r,
                         std::ostream* pstream = nullptr) const final {
      std::vector<double> params_r_vec(params_r.size());
      std::vector<int> params_i;
      transform_inits_impl(context, params_i, params_r_vec, pstream);
      params_r.resize(params_r_vec.size());
      for (int i = 0; i < params_r.size(); ++i) {
        params_r.coeffRef(i) = params_r_vec[i];
      }
    }
    inline void transform_inits(const stan::io::var_context& context,
                                std::vector<int>& params_i,
                                std::vector<double>& vars,
                                std::ostream* pstream = nullptr) const final {
      transform_inits_impl(context, params_i, vars, pstream);
    }        
};
}
using stan_model = model_gl_alt_namespace::model_gl_alt;
#ifndef USING_R
// Boilerplate
stan::model::model_base& new_model(
        stan::io::var_context& data_context,
        unsigned int seed,
        std::ostream* msg_stream) {
  stan_model* m = new stan_model(data_context, seed, msg_stream);
  return *m;
}
stan::math::profile_map& get_stan_profile_data() {
  return model_gl_alt_namespace::profiles__;
}
#endif
#endif
